# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from voucherify.models.campaign_loyalty_card_expiration_rules import CampaignLoyaltyCardExpirationRules
from typing import Optional, Set
from typing_extensions import Self

class CampaignLoyaltyCard(BaseModel):
    """
    Schema model for a campaign loyalty card.
    """ # noqa: E501
    points: Optional[StrictInt] = Field(default=None, description="The initial number of points to assign to the loyalty card. This is the current loyalty card score i.e. the number of loyalty points on the card.")
    expiration_rules: Optional[CampaignLoyaltyCardExpirationRules] = None
    __properties: ClassVar[List[str]] = ["points", "expiration_rules"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CampaignLoyaltyCard from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of expiration_rules
        if self.expiration_rules:
            _dict['expiration_rules'] = self.expiration_rules.to_dict()
        # set to None if points (nullable) is None
        # and model_fields_set contains the field
        if self.points is None and "points" in self.model_fields_set:
            _dict['points'] = None

        # set to None if expiration_rules (nullable) is None
        # and model_fields_set contains the field
        if self.expiration_rules is None and "expiration_rules" in self.model_fields_set:
            _dict['expiration_rules'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CampaignLoyaltyCard from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "points": obj.get("points"),
            "expiration_rules": CampaignLoyaltyCardExpirationRules.from_dict(obj["expiration_rules"]) if obj.get("expiration_rules") is not None else None
        })
        return _obj


