# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from voucherify.models.loyalties_members_transfers_create_response_body_assets_barcode import LoyaltiesMembersTransfersCreateResponseBodyAssetsBarcode
from voucherify.models.loyalties_members_transfers_create_response_body_assets_qr import LoyaltiesMembersTransfersCreateResponseBodyAssetsQr
from typing import Optional, Set
from typing_extensions import Self

class LoyaltiesMembersTransfersCreateResponseBodyAssets(BaseModel):
    """
    Stores links to images of QR and barcode that correspond to an encrypted voucher code.
    """ # noqa: E501
    qr: Optional[LoyaltiesMembersTransfersCreateResponseBodyAssetsQr] = None
    barcode: Optional[LoyaltiesMembersTransfersCreateResponseBodyAssetsBarcode] = None
    __properties: ClassVar[List[str]] = ["qr", "barcode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LoyaltiesMembersTransfersCreateResponseBodyAssets from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of qr
        if self.qr:
            _dict['qr'] = self.qr.to_dict()
        # override the default output from pydantic by calling `to_dict()` of barcode
        if self.barcode:
            _dict['barcode'] = self.barcode.to_dict()
        # set to None if qr (nullable) is None
        # and model_fields_set contains the field
        if self.qr is None and "qr" in self.model_fields_set:
            _dict['qr'] = None

        # set to None if barcode (nullable) is None
        # and model_fields_set contains the field
        if self.barcode is None and "barcode" in self.model_fields_set:
            _dict['barcode'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LoyaltiesMembersTransfersCreateResponseBodyAssets from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "qr": LoyaltiesMembersTransfersCreateResponseBodyAssetsQr.from_dict(obj["qr"]) if obj.get("qr") is not None else None,
            "barcode": LoyaltiesMembersTransfersCreateResponseBodyAssetsBarcode.from_dict(obj["barcode"]) if obj.get("barcode") is not None else None
        })
        return _obj


