# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from voucherify.models.management_projects_branding_get_response_body_address import ManagementProjectsBrandingGetResponseBodyAddress
from voucherify.models.management_projects_branding_get_response_body_brand import ManagementProjectsBrandingGetResponseBodyBrand
from voucherify.models.management_projects_branding_get_response_body_cockpits import ManagementProjectsBrandingGetResponseBodyCockpits
from voucherify.models.management_projects_branding_get_response_body_contact import ManagementProjectsBrandingGetResponseBodyContact
from typing import Optional, Set
from typing_extensions import Self

class ManagementProjectsBrandingGetResponseBody(BaseModel):
    """
    Response body schema for **GET** `/management/v1/projects/{projectId}/branding/{brandingId}`.
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier of the brand configuration.")
    brand: Optional[ManagementProjectsBrandingGetResponseBodyBrand] = None
    address: Optional[ManagementProjectsBrandingGetResponseBodyAddress] = None
    contact: Optional[ManagementProjectsBrandingGetResponseBodyContact] = None
    cockpits: Optional[ManagementProjectsBrandingGetResponseBodyCockpits] = None
    __properties: ClassVar[List[str]] = ["id", "brand", "address", "contact", "cockpits"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ManagementProjectsBrandingGetResponseBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of brand
        if self.brand:
            _dict['brand'] = self.brand.to_dict()
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict['address'] = self.address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of contact
        if self.contact:
            _dict['contact'] = self.contact.to_dict()
        # override the default output from pydantic by calling `to_dict()` of cockpits
        if self.cockpits:
            _dict['cockpits'] = self.cockpits.to_dict()
        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if brand (nullable) is None
        # and model_fields_set contains the field
        if self.brand is None and "brand" in self.model_fields_set:
            _dict['brand'] = None

        # set to None if address (nullable) is None
        # and model_fields_set contains the field
        if self.address is None and "address" in self.model_fields_set:
            _dict['address'] = None

        # set to None if contact (nullable) is None
        # and model_fields_set contains the field
        if self.contact is None and "contact" in self.model_fields_set:
            _dict['contact'] = None

        # set to None if cockpits (nullable) is None
        # and model_fields_set contains the field
        if self.cockpits is None and "cockpits" in self.model_fields_set:
            _dict['cockpits'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ManagementProjectsBrandingGetResponseBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "brand": ManagementProjectsBrandingGetResponseBodyBrand.from_dict(obj["brand"]) if obj.get("brand") is not None else None,
            "address": ManagementProjectsBrandingGetResponseBodyAddress.from_dict(obj["address"]) if obj.get("address") is not None else None,
            "contact": ManagementProjectsBrandingGetResponseBodyContact.from_dict(obj["contact"]) if obj.get("contact") is not None else None,
            "cockpits": ManagementProjectsBrandingGetResponseBodyCockpits.from_dict(obj["cockpits"]) if obj.get("cockpits") is not None else None
        })
        return _obj


