# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from voucherify.models.management_projects_get_response_body_limits_api_calls_item import ManagementProjectsGetResponseBodyLimitsApiCallsItem
from voucherify.models.management_projects_get_response_body_limits_bulk_api_calls_item import ManagementProjectsGetResponseBodyLimitsBulkApiCallsItem
from typing import Optional, Set
from typing_extensions import Self

class ManagementProjectsGetResponseBodyLimits(BaseModel):
    """
    Determines additional limits set on a given project, e.g. the Sandbox project. If no limits are returned, the limits set for the whole organization apply.
    """ # noqa: E501
    api_calls: Optional[List[ManagementProjectsGetResponseBodyLimitsApiCallsItem]] = None
    bulk_api_calls: Optional[List[ManagementProjectsGetResponseBodyLimitsBulkApiCallsItem]] = None
    __properties: ClassVar[List[str]] = ["api_calls", "bulk_api_calls"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ManagementProjectsGetResponseBodyLimits from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in api_calls (list)
        _items = []
        if self.api_calls:
            for _item_api_calls in self.api_calls:
                if _item_api_calls:
                    _items.append(_item_api_calls.to_dict())
            _dict['api_calls'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in bulk_api_calls (list)
        _items = []
        if self.bulk_api_calls:
            for _item_bulk_api_calls in self.bulk_api_calls:
                if _item_bulk_api_calls:
                    _items.append(_item_bulk_api_calls.to_dict())
            _dict['bulk_api_calls'] = _items
        # set to None if api_calls (nullable) is None
        # and model_fields_set contains the field
        if self.api_calls is None and "api_calls" in self.model_fields_set:
            _dict['api_calls'] = None

        # set to None if bulk_api_calls (nullable) is None
        # and model_fields_set contains the field
        if self.bulk_api_calls is None and "bulk_api_calls" in self.model_fields_set:
            _dict['bulk_api_calls'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ManagementProjectsGetResponseBodyLimits from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "api_calls": [ManagementProjectsGetResponseBodyLimitsApiCallsItem.from_dict(_item) for _item in obj["api_calls"]] if obj.get("api_calls") is not None else None,
            "bulk_api_calls": [ManagementProjectsGetResponseBodyLimitsBulkApiCallsItem.from_dict(_item) for _item in obj["bulk_api_calls"]] if obj.get("bulk_api_calls") is not None else None
        })
        return _obj


