# coding: utf-8

"""
    Voucherify API

    Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

    The version of the OpenAPI document: v2018-08-01
    Contact: support@voucherify.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from voucherify.models.campaign import Campaign
from voucherify.models.templates_campaigns_campaign_setup_create_response_body_created_resources_item import TemplatesCampaignsCampaignSetupCreateResponseBodyCreatedResourcesItem
from typing import Optional, Set
from typing_extensions import Self

class TemplatesCampaignsCampaignSetupCreateResponseBody(BaseModel):
    """
    Response body schema for **POST** `/v1/templates/campaigns/{campaignTemplateId}/campaign-setup`.
    """ # noqa: E501
    created_resources: Optional[List[TemplatesCampaignsCampaignSetupCreateResponseBodyCreatedResourcesItem]] = Field(default=None, description="Contains a list of resources that have been added to the project when the campaign has been created out of the template.")
    campaign: Campaign
    object: Optional[StrictStr] = Field(default='campaign_setup', description="The type of the object represented by JSON. This object stores information about the campaign created out of the campaign template.")
    __properties: ClassVar[List[str]] = ["created_resources", "campaign", "object"]

    @field_validator('object')
    def object_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['campaign_setup']):
            raise ValueError("must be one of enum values ('campaign_setup')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TemplatesCampaignsCampaignSetupCreateResponseBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in created_resources (list)
        _items = []
        if self.created_resources:
            for _item_created_resources in self.created_resources:
                if _item_created_resources:
                    _items.append(_item_created_resources.to_dict())
            _dict['created_resources'] = _items
        # override the default output from pydantic by calling `to_dict()` of campaign
        if self.campaign:
            _dict['campaign'] = self.campaign.to_dict()
        # set to None if created_resources (nullable) is None
        # and model_fields_set contains the field
        if self.created_resources is None and "created_resources" in self.model_fields_set:
            _dict['created_resources'] = None

        # set to None if object (nullable) is None
        # and model_fields_set contains the field
        if self.object is None and "object" in self.model_fields_set:
            _dict['object'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TemplatesCampaignsCampaignSetupCreateResponseBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_resources": [TemplatesCampaignsCampaignSetupCreateResponseBodyCreatedResourcesItem.from_dict(_item) for _item in obj["created_resources"]] if obj.get("created_resources") is not None else None,
            "campaign": Campaign.from_dict(obj["campaign"]) if obj.get("campaign") is not None else None,
            "object": obj.get("object") if obj.get("object") is not None else 'campaign_setup'
        })
        return _obj


